/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* ctype.h compatibility */

#ifndef __CORAL_COMPAT_CTYPE_H
# define __CORAL_COMPAT_CTYPE_H



#include <coral/def.h>

#ifdef __PALMOS__

#include <ctype.h> /* no futher inclusion */
#undef _SP
#undef isascii
#undef isalnum
#undef isalpha
#undef iscntrl
#undef isdigit
#undef isgraph
#undef islower
#undef isprint
#undef ispunct
#undef isspace
#undef isupper
#undef tolower
#undef toupper

#define NON_INTERNATIONAL
#include <System/CharAttr.h>
#define isascii IsAscii
#define isalnum(c) IsAlNum(GetCharAttr(),c)
#define isalpha(c) IsAlpha(GetCharAttr(),c)
#define iscntrl(c) IsCntrl(GetCharAttr(),c)
#define isdigit(c) IsDigit(GetCharAttr(),c)
#define isgraph(c) IsGraph(GetCharAttr(),c)
#define islower(c) IsLower(GetCharAttr(),c)
#define isprint(c) IsPrint(GetCharAttr(),c)
#define ispunct(c) IsPunct(GetCharAttr(),c)
#define isspace(c) IsSpace(GetCharAttr(),c)
#define isupper(c) IsUpper(GetCharAttr(),c)
#define tolower(c) (isupper(c)?c-('A'-'a'):c)
#define toupper(c) (islower(c)?c-('a'-'A'):c)

#else /* !__PALMOS__ */

#include <ctype.h>

#endif /* __PARMOS__ */


#endif /* __CORAL_COMPAT_CTYPE_H */
