/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* Compatibility for memory.h */

#ifndef __CORAL_COMPAT_MEMORY_H
# define __CORAL_COMPAT_MEMORY_H

#include <coral/def.h>



#ifdef __STDC__

#	include <stdlib.h> //???_EiC
#	include <string.h>

#else /* !__STDC__ */

#ifdef __PALMOS__

/* define memory routines for palmos */
#	include <System/MemoryMgr.h>
#	define memset(dest,val,size) MemSet(dest,size,val)
#	define memcmp MemCmp
#	define memcpy MemMove

#else /* !__PALMOS__ */
#if defined(__GNUC__) || defined(__MACOS__)

#	include <string.h>

#else /* !__GNUC__ */
#if defined(__TURBOC__) || defined(__WATCOMC__)

#	include <mem.h>

#else /* !__TURBOC__ && !__WATCOMC__ */

#	include <memory.h>

#endif /* __TURBOC__ || __WATCOMC__ */
#endif /* __GNUC__ */
#endif /* __PALMOS__ */

#endif /* __STDC__ */



#endif /* __CORAL_COMPAT_MEMORY_H */
