/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* Compatibility for string.h */

/*
 strcat, appending a string to another
 strcmp, case sensitive comparison
 strcmpi, case insensitive comparison
 strncmp, comparison of two string using the limited length
 strncmpi, case insensitive comparision using the limited length
 strcpy, copy source string to destination
 strlen, string length
 strlwr, convert characters in a string to lower case
 strupr, convert characters in a string to upper case
*/


#ifndef __CORAL_COMPAT_STRING_H
# define __CORAL_COMPAT_STRING_H

//??????? mac os : strcmpi, strncmpi

#include <coral/def.h>



__CBEGIN__



#ifdef __PALMOS__



#include <coral/compat/memory.h>
#include <System/StringMgr.h>
#define strcat StrCat
#define strchr StrChr
#define strcmp StrCompare
#define strcmpi StrCaselessCompare
#define strncmp StrNCompare
#define strncmpi StrNCaselessCompare
#define strcpy StrCopy
#define strlen StrLen
#define strlwr(s) StrToLower(s,s)
#define DEFINE_strupr
_CAPI( char __F*, strupr, ( char __F* s ) );



#else /* !__PALMOS__ */



# include <string.h>



#ifdef __UNIXC__

# define strcmpi  strcasecmp
# define strncmpi strncasecmp

#ifndef DJGPP
#define DEFINE_strlwr
#define DEFINE_strupr
_CAPI( char __F*, strlwr, ( char __F* s ) );
_CAPI( char __F*, strupr, ( char __F* s ) );
#endif /* DJGPP */

#else /* !__UNIXC__ */
#ifdef __MACOS__

#define DEFINE_stricmp
#define DEFINE_strnicmp
_CAPI( int, stricmp, ( const char __F* s1, const char __F* s2 ) );
_CAPI( int, strnicmp, ( const char __F* s1, const char __F* s2, size_t count ) );

#else /* !__MACOS__ */
#ifdef __WIN32__
# define strncmpi strnicmp
#else /* !__WIN32__ */
#if defined(__DOS16__) || defined(__WIN16__)

# define strcmp   _fstrcmp
# define strcmpi  _fstricmp
# define strncmp  _fstrncmp
# define strncmpi _fstrnicmp
# define strcat   _fstrcat
# define strcpy   _fstrcpy
# define strlen   _fstrlen
# define strlwr   _fstrlwr
# define strupr   _fstrupr

#endif /* __DOS16__ || __WIN16__ */
#endif /* __WIN32__ */
#endif /* __MACOS__ */
#endif /* __UNIX__ */
#endif /* __PALMOS__ */



__CEND__



#endif /* __CORAL_COMPAT_STRING_H */
