/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* unistd.h compatibility

 Not all routines in unistd.h are compatible. */

#ifndef __CORAL_COMPAT_UNISTD_H
# define __CORAL_COMPAT_UNISTD_H

//????????????? mac - open is defined in fcntl.h

/*** Include files */

#include <coral/def.h>

#ifdef __UNIXC__

# include <unistd.h>

#else /* __UNIX__ */
#ifdef __MACOS__
#else /* !__MACOS__ */

# include <io.h>

# if defined(__TURBOC__) && __TURBOC__<=0x200
#  include <dir.h>
# else
#  include <direct.h>
# endif

# include <process.h> /* exec */

#endif /* __MACOS__ */
#endif /* __UNIX__ */



/*** Definitions to be compatible */

#ifndef PATH_MAX

/* try to get it */
#include <limits.h> /* evidently for msc */

#ifndef PATH_MAX

# if defined(MAXPATH) /* probably borland c */
#  define PATH_MAX MAXPATH
# else
#  define PATH_MAX 256 /* use posix rule */
# endif

#endif /* !PATHMAX */

#endif /* !PATHMAX */



/* Flags for 'access' */
#ifndef F_OK
# define F_OK 0x0000
# define X_OK 0x0001
# define W_OK 0x0002
# define R_OK 0x0004
#endif



/*** Routines to be compatible */


/* except getcwd extension supported compilers */
#if !defined(__GNUC__) && !defined(_MSC_VER)

#define compat_getcwd compat_getcwd_api
_API( char*, compat_getcwd, ( char* buf, int size ) );

#ifndef __COMPAT__
# define getcwd compat_getcwd
#endif

#endif



#endif /* __CORAL_COMPAT_UNISTD_H */
