/* Coral library for low level data structure implementation
 Copyright (C) 1996-2001 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* C language parser */


#ifndef __CORAL_CPARSER_H
#	define __CORAL_CPARSER_H


#include <coral/io.h>



/* _CSOURCE */

DECLARE_BALANCED_BINTREE( _CSOURCE )
	char name[1]; /* the source file name */
DECLARE_END;



/* _CPARSER */

struct _CPARSER {
	struct _IO           io;
	struct _IOTEXT       iot;
	struct _CSOURCE __F* source;
	unsigned             error;   /* error code */
};



__CBEGIN__



_API( int, cInitializeParser, ( struct _CPARSER __F* cp, struct _IO __F* io, const char __F* srcname ) );
_API( struct _RECORD __F* , cParseStructureMember, ( struct _CPARSER* cparser ) );


__CEND__


#endif /* __CORAL_CPARSER_H */

