/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* Directory Operations */

#ifndef __CORAL_DIR_H
# define __CORAL_DIR_H



#include <coral/def.h>



/* dirCreate, option flags */

#define DIR_FLAG_FILE_NAME 0x1000 /* the given string is a file name */



/* dirTrace */


/* flag : generic flag
 name : name without path */
#define DECLARE_DIRTRACE(tag) struct tag { unsigned flag; char __F* name;

DECLARE_DIRTRACE(_DIRTRACE)
DECLARE_END;


/* return values for callback
zero to continue, nonzero to terminate */


/* option flags */
#define DIR_FLAG_RECURSIVE        0x0001  /* trace sub-directories */
#define DIR_FLAG_NOTIFY           0x0002  /* send directory found notification, _DIRTRACE object must be supplied for notification */
#define DIR_FLAG_LEAVE_NOTIFY     0x0004  /* send directory leaving notification, _DIRTRACE object must be supplied for notificatio */
#define DIR_FLAG_TRACE_SYMLINK    0x0008  /* trace symbolic linked directories */
#define DIR_FLAG_NOTIFY_SYMLINK   0x0010  /* notify symbolic link, if symlink is directory, FILE_FLAG_DIRECTORY_NOTIFY will also be posted */



__CBEGIN__



_API( int, dirCreate, ( const char __F* path, unsigned mode, unsigned flag, int __F* pos ) );
_API( int, dirRemove, ( const char __F* path, unsigned flag, int (__API* confirm) P_A(( const char* name, void __F* param )), void __F* param ) );
_API( int, dirCopy, ( const char __F* path, unsigned flag ) );
_API( int, dirTrace, ( const char __F* dir, int (__API* trace)( const char __F*name, struct _DIRTRACE __F* dt ), struct _DIRTRACE __F* dt, unsigned flag ) );



__CEND__



#endif /* __CORAL_DIR_H */

