/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* String Informations

 OS_NAME
 OS_Name
 OS_name
 OS_DETAIL
 OS_Detail
 OS_detail

 COMPILER_INFO
 COMPILER_Info
 COMPILER_info */


#ifndef __CORAL_STRDEF_H
# define __CORAL_STRDEF_H

#include <coral/def.h>



/* Generic strings */

#define NOT_AVAILABLE "N/A"



/* Platform strings */

#ifdef __UNIX__

# define OS_NAME  "UNIX"
# define OS_Name  "Unix"
# define OS_name  "unix"

# ifdef linux
#  define OS_DETAIL "LINUX"
#  define OS_Detail "Linux"
#  define OS_detail "linux"
# else /* !linux */
# ifdef __sgi
#  define OS_DETAIL "IRIX"
#  define OS_Detail "Irix"
#  define OS_detail "irix"
# else /* !__sgi */
# ifdef __hpux
#  define OS_DETAIL "HPUX"
#  define OS_Detail "HPUX"
#  define OS_detail "hpux"
# endif /* __hpux */
# endif /* __sgi */
#endif /* linux */

#else /* !__UNIX__ */
#ifdef __BEOS__

# define OS_NAME "BEOS"
# define OS_Name "BeOS"
# define OS_name "beos"

#else /* !__BEOS__ */
#ifdef __MACOS__

# define OS_NAME "MACOS"
# define OS_Name "MacOS"
# define OS_name "macos"



#else /* !__MACOS__ */
#ifdef __PALMOS__

# define OS_NAME "PALMOS"
# define OS_Name "PalmOS"
# define OS_name "palmos"

#else /* !__PALMOS__ */
#ifdef __WINDOWS__

# define OS_NAME  "WINDOWS"
# define OS_Name  "Windows"
# define OS_name  "windows"

# ifdef __WIN32__
#  define OS_DETAIL "WIN32"
#  define OS_Detail "Win32"
#  define OS_detail "win32"
# else
#  define OS_DETAIL "WIN16"
#  define OS_Detail "Win16"
#  define OS_detail "win16"
# endif /* __WIN32__ */

#else /* !__WINDOWS__ */
#ifdef __DOS__

# define OS_NAME  "DOS"
# define OS_Name  "Dos"
# define OS_name  "dos"

# ifdef __DOS16__
#  define OS_DETAIL "DOS16"
#  define OS_Detail "Dos16"
#  define OS_detail "dos16"
# else
#  define OS_DETAIL "DOS32"
#  define OS_Detail "Dos32"
#  define OS_detail "dos32"
# endif /* __DOS16 */

#else /* !__DOS__ */

# define OS_NAME  NOT_AVAILABLE
# define OS_Name  NOT_AVAILABLE
# define OS_name  NOT_AVAILABLE

#endif /* __DOS__ */
#endif /* __WINDOWS__ */
#endif /* __PALMOS__ */
#endif /* __MACOS__ */
#endif /* __BEOS__ */
#endif /* __UNIX__ */


#ifndef OS_DETAIL
# define OS_DETAIL NOT_AVAILABLE
# define OS_Detail NOT_AVAILABLE
# define OS_detail NOT_AVAILABLE
#endif /* OS_DETAIL */



/* Compiler strings */

#ifdef __GNUC__
# define COMPILER_INFO "GNU"
# define COMPILER_Info "GNU"
# define COMPILER_info "gnu"
#else /* !__GNUC__ */
#ifdef _EiC /* Extensible Interactive C */
# define COMPILER_INFO "EIC"
# define COMPILER_Info "EiC"
# define COMPILER_info "eic"
#else /* !_EiC */
#ifdef __sgi
# define COMPILER_INFO "SILICON GRAPHICS"
# define COMPILER_Info "Silicon Graphics"
# define COMPILER_info "silicon graphics"
#else /* !__sgi */
#ifdef __hpux
# define COMPILER_INFO "HEWLETT-PACKARD"
# define COMPILER_Info "Hewlett-Packard"
# define COMPILER_info "hewlett-packard"
#else /* !__hpux */
#ifdef MPW
# define COMPILER_INFO "APPLE"
# define COMPILER_Info "Apple"
# define COMPILER_info "apple"
#else /* !MPW */
#ifdef __TURBOC__
# define COMPILER_INFO "BORLAND"
# define COMPILER_Info "Borland"
# define COMPILER_info "borland"
#else /* !__TURBOC__ */
#ifdef __WATCOMC__
# define COMPILER_INFO "WATCOM"
# define COMPILER_Info "Watcom"
# define COMPILER_info "watcom"
#else /* !__WATCOMC__ */
#ifdef _MSC_VER
# define COMPILER_INFO "MICROSOFT"
# define COMPILER_Info "Microsoft"
# define COMPILER_info "microsoft"
#else /* !_MSC_VER */
# define COMPILER_INFO NOT_AVAILABLE
# define COMPILER_Info NOT_AVAILABLE
# define COMPILER_info NOT_AVAILABLE
#endif /* _MSC_VER */
#endif /* __WATCOMC__ */
#endif /* __TURBOC__ */
#endif /* MPW */
#endif /* __hpux */
#endif /* __sgi */
#endif /* _EiC */
#endif /* __GNUC__ */


#endif /* __CORAL_STRDEF_H */
