/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


/* Coral Binary Tree Implementation */



#ifndef __CORALSRC_BINTREE_H
# define __CORALSRC_BINTREE_H

#include <coralsrc/def.h>
#include <coral/bintree.h>



/* hidden flags for bintreeCreate */
#define _BINTREE_FLAG_INTERNAL_CREATION 0x0000 /* node needs to be internally created */
#define _BINTREE_FLAG_EXTERNAL_CREATION 0x8000 /* node was externally created */



__CBEGIN__



_bool bintree_realloc_path P_A(( struct _BINTREEITERPATH __F* iterpath, struct _BINTREEITERITEM __F*__F* pathcache, int __F* lastcache ));
_bool bintree_avl_rotate P_A(( struct _BINTREE __F*__F* root, struct _BINTREEITERPATH __F* iterpath, _bool del ));



__CEND__



#endif /* __CORALSRC_BINTREE_H */
