/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


/* Internal header file for process.h */



#ifndef __CORALSRC_EXT_PROCESS_H
# define __CORALSRC_EXT_PROCESS_H



#include <coralsrc/def.h>



#define THREAD_FLAG_JOINED 0x8000 /* thread was already joined */



#ifdef __WIN32__

typedef DECLARE_DLIST( _thread_context )
  void __F* handle; /* thread handle */
  void __F* (__API* start) P_A(( void __F* param )); /* starting routine */
  void __F* param; /* parameter for the starting routine */
  unsigned flag;   /* flag */
DECLARE_END __F* THREADCONTEXT;

/* actual mutex context is defined in the source */

#ifndef THREAD_MUTEX_DEFINED
DECLARE_CLASS(THREADMUTEX);
#endif

void thread_free P_A(( THREADCONTEXT thread ));
//#define THREAD_OBJECT 

#endif /* __WIN32__ */



#include <coral/ext/process.h>
extern THREADKEY thread_context_key;
extern int thread_init_count;



#endif /* __CORALSRC_EXT_PROCESS_H */

