/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/* Coral Open I/O*/



#ifndef __CORALSRC_IO_H
# define __CORALSRC_IO_H

#include <coralsrc/def.h>
#include <coral/io.h>



#define _IO_DEFAULT_BUFFER 512    /* default buffer size */



/* iotextConv */
#define _IOTEXT_FLAG_MEMORY  0x10 /* given source stream is a memory pointer */



/* _io_buffer */
struct _io_buffer {
	int size;                  /* size of buffer */
	int rend;                  /* read bytes in buffer for read mode */
	int reserved;              /* size to reserve the current buffer contents */
	int wend;                  /* written bytes in buffer for write mode */
	int current;               /* current position of buffer */
	int lastop;                /* last operation */
	unsigned long offset;      /* low part of the current offset */
	long          offset_high; /* high part of the current offset */
	_integer1 buf[sizeof(int)]; /* buffer */
};




extern struct _IOTEXT  io_text_default;
extern char io_text_white_char[];


__CBEGIN__



/*                *\

  Internal methods

\*                */



int __API io_ready_wmode P_A(( struct _IO __F* io, long n ));
int __API io_ready_rmode P_A(( struct _IO __F* io, long n ));
void __API io_reset_buffer P_A(( struct _io_buffer __F* buffer ));
_bool __API io_operate_record P_A(( struct _IO __F* io, void __F* p, const void __F* ri, unsigned flag, _bool (__API* ioproc) P_A((struct _IO __F* io,void __F* p,long n,unsigned byteorder)) ));
_bool __API io_operate_2d  P_A(( struct _IO __F* io, void __F* p, long row, unsigned short item, const void __F* colrow, const void __F* colcol, _unsigned2 variable, _unsigned2 byteorder, _bool (__API* ioproc)P_A((struct _IO __F* io,void __F* p,long n,unsigned byteorder)) ));



__CEND__



#endif /* __CORALSRC_IO_H */
