/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


/* Operation ( Undo & Redo ) log */


#ifndef __CORALSRC_OPLOG_H
# define __CORALSRC_OPLOG_H



#include <coralsrc/def.h>



typedef struct _oplog_context __F* OPLOGCONTEXT;



#include <coral/oplog.h>



/* _oplog_context */

struct _oplog_context {
	struct _OPLOG __F* undo, __F* redo;      /* roots for undo and redo logs */
	_DIOHANDLE         undo_dioh, redo_dioh; /* dio roots for undo and redo log */
	struct _DIO __F*   dio;                  /* dio to swap logs */
	OPLOGCALLBACK      callback;             /* callback for op logs */
	void __F*          param;                /* external parameter to be supplied to callback function */
	unsigned           flag;                 /* flags */
	unsigned           total_count;          /* number of log count, zero means unlimited */
	unsigned           cache_count;          /* number of cached log count */
	unsigned           current_count;        /* the current log count */
};



/* _oplog_context, flag */

#define _OPLOG_FLAG_UNDO                0x0100  /* undo is enabled */
#define _OPLOG_FLAG_REDO                0x0200  /* redo is enabled */
#define _OPLOG_FLAG_STRING_CODE         0x0400  /* string code is used */
#define _OPLOG_FLAG_EXECUTE_REDO       0x4000  /* execute redo */
#define _OPLOG_FLAG_MULTI_TRANSACTION  0x8000  /* multi-transaction is requested */



__CBEGIN__






__CEND__



#endif /* __CORALSRC_OPLOG_H */

