/* Coral library for low level data structure implementation
 Copyright (C) 1996-2004 Hee S. Chung

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */



#include <coralsrc/memory.h>
#include <coralsrc/type.h>



__MODULEBEGIN__( "ttravcl.c" )
/* typeTraverseClass */
/* XXX
type-defined class symbols
property-scan for arrays
how can trace pointers?
pointer of an array
array of a pointer
*/

int __API
typeTraverseClass
	P_B(( cl, traverse, param ))
	P_1		struct _TYPE_CLASS* cl
	P_N		int (__API* traverse)( struct _TYPE_CLASS __F* cl, struct _TYPE_SYMBOL* symbol, unsigned action, void __F* param )
	P_N		void __F* param
	P_E
{
	struct _stack {
		struct _TYPE_CLASS* cl;
		unsigned imember;
	} stack_buf[10], __F* stack = stack_buf;
	int result = 0;
	int istack = 0, imember = 0;

	while( 1 ) {
		struct _stack __F* curstack;
		struct _TYPE_CLASS_MEMBER __F* member = cl->member;
		/* iterate members */
		if( member ) {
			int nmember = member->nelem;
			struct _TYPE_SYMBOL __F* symbol = member->elem + imember;

			while( imember<nmember ) {
				unsigned code = symbol->code;
				if( code&TC_FLAG_CLASS ) {
					result = traverse
						( cl, symbol, TYPE_TRACE_CLASS, param );
					imember++;
					/* imember should be increase above, to terminate this
						function if result<0 */
					if( result!=0 ) {
						if( result<0 ) istack = 0;
						break;
					}
					/* push the current class */
					curstack = &stack[istack++];
					curstack->cl = cl;
					curstack->imember = imember;
					cl = symbol->base.cl;
					imember = 0;
					break;
				}
				else {
					traverse( cl, symbol, TYPE_CLASS_MEMBER, param );
				}
				imember++;
				symbol++;
			} /* end while( imember<nmember ) */
			if( imember<nmember ) continue;
		} /* end if( member ) */

		if( istack<=0 ) break;

		/* pop stack */
		curstack = &stack[--istack];
		imember = curstack->imember;
		cl = curstack->cl;
	} /*end while( 1 ) */

	if( stack!=stack_buf )
		memFree( stack );

	return result;
}

__MODULEEND__



/* EOF */

