# Common definitions
# Hee S. Chung

ifndef __UNIX_GCC_DEF_MK
__UNIX_GCC_DEF_MK=1

# Predefined macros

ifndef MK_OUT_ROOT
MK_OUT_ROOT=$(MK_DEVEL)/out
endif

ifndef MK_LIB_ROOT
MK_LIB_ROOT=$(MK_DEVEL)/lib
endif

ifndef MK_MODE
MK_MODE=r
endif

_MK_CC_COMMON=gcc -c -Wall -o$@ -I$(MK_DEVEL) $(_MK_CC_OPT) $(MK_CC_OPT)
_MK_CC=$(_MK_CC_COMMON)
_MK_CXX=$(_MK_CC_COMMON) $(MK_CXX_OPT)
_MK_LD_OPT=-L$(MK_LIB) -L$(MK_SH) -L/usr/X11R6/lib

MK_RM=rm -f
OBJ_EXT=o

ST_PREFD=lib
ST_PREFR=lib
ST_PREF=lib
ST_SUFFD=_d.a
ST_SUFFR=.a

SH_PREFD=lib
SH_PREFR=lib
SH_PREF=lib
SH_SUFFD=_d.so
SH_SUFFR=.so

LST_PREFD=-l
LST_PREFR=-l
LST_PREF=-l
LST_SUFFD=_d

LSH_PREFD=-l
LSH_PREFR=-l
LSH_PREF=-l
LSH_SUFFD=_d

ifeq ($(MK_MODE),d)
	ST_SUFF=$(ST_SUFFD)
	SH_SUFF=$(SH_SUFFD)
	LST_SUFF=$(LST_SUFFD)
	LSH_SUFF=$(LSH_SUFFD)
	_MK_CC_OPT=-g -D__DEBUG__
else
	ifeq ($(MK_OPTIMIZE),FAST)
		_MK_CC_OPT=-O2
	else
	ifeq ($(MK_OPTIMIZE),SIZE)
		_MK_CC_OPT=-O1
	endif
	endif
	ST_SUFF=$(ST_SUFFR)
	SH_SUFF=$(SH_SUFFR)
	LST_SUFF=$(LST_SUFFR)
	LSH_SUFF=$(LSH_SUFFR)
endif


LIB_DL=-ldl
LIB_THREAD=-lpthread


endif # __UNIX_GCC_DEF_MK

