# Common definitions
# Hee S. Chung, Distributed under GNU LGPL


!ifndef __WIN32_VC_DEF_MK
__WIN32_VC_DEF_MK=1


# Predefined macros

!ifndef MK_OUT_ROOT
MK_OUT_ROOT=$(MK_DEVEL)\out
!endif

!ifndef MK_OUT_PATH
MK_OUT_PATH=$(MK_OUT_ROOT)\$(MK_OS)
!endif

!ifndef MK_LIB_ROOT
MK_LIB_ROOT=$(MK_DEVEL)\lib
!endif

!ifndef MK_MODE
MK_MODE=r
!endif

!ifndef MK_CC_DEBUG_OPT
MK_CC_DEBUG_OPT=/Z7 /D__DEBUG__ /D_DEBUG
!endif

!ifndef MK_CXX_DEBUG_OPT
MK_CXX_DEBUG_OPT=$(MK_CC_DEBUG_OPT)
!endif

!ifndef MK_CC_FAST_OPT
MK_CC_FAST_OPT=/O2
!endif

!ifndef MK_CXX_FAST_OPT
MK_CXX_FAST_OPT=$(MK_CC_FAST_OPT)
!endif

EXE_SUFF=.exe
LIB_MOD=32
ST_SUFFD=d.lib
ST_SUFFR=.lib
SH_SUFFD=d.dll
SH_SUFFR=.dll

!if "$(MK_MODE)"=="d"

ST_SUFF=$(ST_SUFFD)
SH_SUFF=$(SH_SUFFD)
_LIB_MODE=d
_MK_CC_OPT=$(MK_CC_DEBUG_OPT)
_MK_LD_OPT=-DEBUG

!else

!if "$(MK_OPTIMIZE)"=="FAST"
_MK_CC_OPT=/O2
!else
!if "$(MK_OPTIMIZE)"=="SIZE"
_MK_CC_OPT=/O1
!endif
!endif # MK_OPTIMIZE

ST_SUFF=$(ST_SUFFR)
SH_SUFF=$(SH_SUFFR)

!endif # MK_MODE


!if "$(MK_PROFILE)"=="y"
_MK_LD_OPT=$(_MK_LD_OPT) /profile
!endif


LST_PREF=$(ST_PREF)
LST_SUFF=$(ST_SUFF)

LSH_PREF=$(ST_PREF)
LSH_SUFF=$(ST_SUFF)

LSH_PREFR=$(ST_PREFR)
LSH_SUFFR=$(ST_SUFFR)

MK_RM=del
MK_CP=copy
OBJ_EXT=obj


# Libraries
LIB_UI=user32.lib gdi32.lib
LIB_OPENGL=opengl32.lib
LIB_GLU=glu32.lib
LIB_GLUT=glut32.lib
LIB_GLAUX=advapi32.lib glaux.lib

!ifndef MK_SHARED_PATH
MK_SHARED_PATH=$(MK_SH)
!endif

!ifndef LIBW_DLL_FILE
LIBW_DLL_FILE=$(MK_SHARED_PATH)\$(SH_NAME)$(_LIB_MODE).dll
!endif

!ifndef MK_LIB_PATH
MK_LIB_PATH=$(MK_LIB_ROOT)\$(MK_OS)\$(MK_COMPILER)
!endif

# Internal compiler command

_MK_CC_COMMON=cl /c /Fo$@ $(_MK_CC_OPT) $(MK_CC_OPT) /D__EXPORT__
_MK_CC=$(_MK_CC_COMMON)
_MK_CXX=$(_MK_CC_COMMON) /GX $(MK_CXX_OPT)


!if "$(MK_CROSS)"=="rtx"

!if "$(RTX_VERSION)"=="4"
RTX_ROOT=$(RTX4_ROOT)
!else
RTX_ROOT=$(RTX5_ROOT)
!endif

_MK_CC=$(_MK_CC) /I$(RTX_ROOT)\include
_MK_CXX=$(_MK_CXX) /I$(RTX_ROOT)\include
_MK_LD_OPT=$(_MK_LD_OPT) /LIBPATH:$(RTX_ROOT)\lib rtapi_w32.lib
!endif # end of "$(MK_CROSS)"=="rtx"


!if "$(RTX_TARGET)"=="rtx"

_EX_EXT=rtss
_MK_CC=$(_MK_CC) /MT
_MK_CXX=$(_MK_CXX) /MT
!if "$(MK_MODE)"=="d"
_MK_LD_OPT=-DEBUG:notmapped /PDB:NONE
# -DEBUGTYPE:BOTH
!endif

!if "$(RTX_LIBC)"=="true"

_MK_LD_OPT=$(_MK_LD_OPT) -entry:_RtapiProcessEntryCRT@8 $(RTX_ROOT)\lib\startupCRT.obj
# libc should be placed prior to rtxxx libraries
!if "$(MK_CROSS)"=="rtx4"
!ifdef RTX4_WIN32VC_LIBC
_MK_LD_OPT=$(_MK_LD_OPT) $(RTX4_WIN32VC_LIBC)
!else
_MK_LD_OPT=$(_MK_LD_OPT) libcmt.lib
!endif
!else
_MK_LD_OPT=$(_MK_LD_OPT) rtxlibcmt.lib
!endif

!else

_MK_LD_OPT=$(_MK_LD_OPT) -entry:_RtapiProcessEntry@8

!endif # RTX_LIBC

_MK_LD_OPT= -driver -align:0x20 -subsystem:native,4.00 /NODEFAULTLIB /NODEFAULTLIB:libcmt /NODEFAULTLIB:libcmtd /LIBPATH:$(RTX_ROOT)\lib $(_MK_LD_OPT) $(_EX_MODULE) rtapi_rtss.lib rtx_rtss.lib w32_dll.lib


!else # "$(RTX_TARGET)"!="rtx"
_EX_EXT=exe
_MK_CC=$(_MK_CC) /MD$(_LIB_MODE)
_MK_CXX=$(_MK_CXX) /MD$(_LIB_MODE)
_MK_LD_OPT=$(_MK_LD_OPT) /INCREMENTAL:NO /PDB:NONE # -DEBUG:notmapped -DEBUGTYPE:both
!endif # "$(RTX_TARGET)"=="rtx"


!if "$(MK_TARGET)"=="gui"
_MK_LD_OPT=$(_MK_LD_OPT) /SUBSYSTEM:WINDOWS
!endif

!endif # __WIN32_VC_DEF_MK


#  end of def.d

