# Makefile to generate a shared library file
# Hee S. Chung, Distributed under GNU LGPL


!include $(MK_TEMPLATE)\def.d


!ifdef SH_SRC


!ifndef SH_SRCPATH
SH_SRCPATH=.
!endif


!ifndef SH_SRCEXT
SH_SRCEXT=c
!endif

!ifndef SH_NAME
SH_NAME=$(SH_SRC)
!endif

_SH_SRC_OBJ=$(MK_OUT)\$(SH_SRC).obj
_SH_RM_SRC_OBJ= $(MK_RM) $(_SH_SRC_OBJ)

!else

!ifndef SH_NAME
SH_NAME=shared
!endif

!endif # SH_SRC

SH_CC=$(_MK_CC)
SH_CXX=$(_MK_CXX)

!if "$(SH_SRCEXT)"=="c"
_SH_CC=$(SH_CC)
!else
_SH_CC=$(SH_CXX)
!endif


!ifdef SHW_DEF
SHW_DEF_OPT=/DEF:$(SHW_DEF)
!endif


# Generate library

$(MK_SH)\$(SH_PREF)$(SH_NAME)$(SH_SUFF): $(_SH_SRC_OBJ) $(SH_OBJ) $(SH_DEPEND)
	link /DLL $(_MK_LD_OPT) $(MK_LD_OPT) /IMPLIB:$(MK_LIB)\$(ST_PREF)$(SH_NAME)$(ST_SUFF) /OUT:$(LIBW_DLL_FILE) $(SHW_DEF_OPT) $(_SH_SRC_OBJ) $(SH_OBJ) $(SH_LIB)


# Generate source object file

!ifdef SH_SRC
$(_SH_SRC_OBJ) : $(SH_SRCPATH)\$(SH_SRC).$(SH_SRCEXT)
	$(_SH_CC) $(SH_SRCPATH)\$(SH_SRC).$(SH_SRCEXT)
!endif


# Clean output files

clean_shared:
	$(_SH_RM_SRC_OBJ)
	$(MK_RM) $(MK_LIB_PATH)\$(ST_PREF)$(SH_NAME)$(ST_SUFF)
	$(MK_RM) $(LIBW_DLL_FILE)


# end of shared.d

