# Makefile to generate a library file
# Hee S. Chung, Distributed under GNU LGPL


!include $(MK_TEMPLATE)\def.d


!ifdef ST_SRC


!ifndef ST_SRCPATH
ST_SRCPATH=.
!endif


!ifndef ST_SRCEXT
ST_SRCEXT=c
!endif

!ifndef ST_NAME
ST_NAME=$(ST_SRC)
!endif

_ST_SRC_OBJ=$(MK_OUT)\$(ST_SRC).obj
_ST_RM_SRC_OBJ= $(MK_RM) $(_ST_SRC_OBJ)

!else

!ifndef ST_NAME
ST_NAME=static
!endif

!endif # ST_SRC

ST_CC=$(_MK_CC)
ST_CXX=$(_MK_CXX)


!if "$(ST_SRCEXT)"=="c"
_ST_CC=$(ST_CC)
!else
_ST_CC=$(ST_CXX)
!endif


# Generate library



$(MK_LIB_PATH)\$(LIB_PREF)$(ST_NAME)$(LIB_SUFF) : $(_ST_SRC_OBJ) $(ST_OBJ) $(ST_DEPEND)
	lib /OUT:$@ $(_ST_SRC_OBJ) $(ST_OBJ) $(ST_LIB)


# Generate source object file

!ifdef ST_SRC
$(_ST_SRC_OBJ) : $(ST_SRCPATH)\$(ST_SRC).$(ST_SRCEXT)
	$(_ST_CC) $(ST_SRCPATH)\$(ST_SRC).$(ST_SRCEXT)
!endif


# Clean output files

clean_static:
	$(_ST_RM_SRC_OBJ)
	$(MK_RM) $(MK_LIB_PATH)\$(LIB_PREF)$(ST_NAME)$(LIB_SUFF)


# end of static.d

