/* An example for Coral IOTEXT */

#include <stdio.h>
#include <coral/io.h>


struct _IOLOCKMEMORY iom;
struct _IOBUFFER iob = { (ANYCONTEXT)&iom,
	(_IOLOCKBUFFER)ioLockMemory, (_IOUNLOCKBUFFER)ioUnlockMemory };
struct _IOTEXT iot = { 1, 0, 2, 2, 2, "//", "/*", "*/" };


char s[] =
" // PARAM1\n"
"    PARAM1 =          \"Hello\"\n"
" PARAM2\t\t\t  /* PARAM2\n"
"   PARAM2 */ = /* PARAM2 */ \"World\"";

char buf[256];


int
main( void )
{
	int result;

	ioInitializeMemoryBuffer( &iob, &iom, s, sizeof(s) );

	printf( "Original texts :\n\n%s\n\nFound parameters:\n\n", s );

	while( (result=iotextRead( &iob, "=", buf, sizeof(buf), 0, &iot )) >0 ) {

		/* result was successful but returned reason for iotextRead was not
			IOTEXT_DELIMITER so wait delimiter without any garbage */
		if( result!=IOTEXT_DELIMITER && iotextWait( &iob, "=", &iot )<=0 ) {
			printf( "\n\nStop : invalid parameter was found at line %lu\n",
				iot.line );
			break;
		}

		printf( "%s = ", buf );

		if( iotextReadString
				( &iob, buf, sizeof(buf), '"', '"', 0, 0, &iot )<=0 ) {
			printf( "\n\nStop : invalid string was found at line %lu\n",
				iot.line );
			break;
		}

		printf( "%s\n", buf );
	}

	return 0;
}



/* EOF */

